const { machine } = require('asyncmachine')

const example = machine(['Stable', 'Broken'])
  .id('')
  .logLevel(2)

// state negotiation
example.Broken_enter = function() {
  let clock = this.clock('Exception')
  console.log(`Exception clock == ${clock}`)
  if (clock > 5) {
    console.log('Too many errors, quitting')
    return false
  }
}

// state set
example.Broken_state = function() {
  throw Error('random exception')
}

// use the state negotiation for fault tolerance
example.Exception_state = function(
  err,
  target_states,
  base_states,
  exception_src_handler,
  async_target_states
) {
  // try to rescue the Broken state
  if (target_states.includes('Broken')) {
    console.log('Retrying the Broken state')
    this.drop('Exception')
    this.add('Broken')
  }
}

example.add(['Stable', 'Broken'])
example.is();
